using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC_EmptyDataSource
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(48, 40);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(496, 384);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.0.1.0";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(96, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(320, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Click to change two cell values in two rows";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 462);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region Get the DataSource
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 30;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = i;
				dt.Rows.Add(dr);
			}

			#endregion

			dt.AcceptChanges();
			this.gridGroupingControl1.DataSource = dt;

			this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.None;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
			this.gridGroupingControl1.ShowGroupDropArea = true;

			this.gridGroupingControl1.TableControlCurrentCellControlKeyMessage += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellControlKeyMessageEventHandler(this.gridGroupingControl1_TableControlCurrentCellControlKeyMessage);
			this.gridGroupingControl1.TableControlKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlKeyDown);
			
			this.gridGroupingControl1.TableControl.Model.ClipboardCopy += new GridCutPasteEventHandler(Model_ClipboardCopy);

			
		}


		

		private void gridGroupingControl1_TableControlCurrentCellControlKeyMessage(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellControlKeyMessageEventArgs e) 
		{
			Keys keyCode = (Keys) ((int)e.Inner.Msg.WParam) & Keys.KeyCode;
			if(keyCode == Keys.A && e.Inner.Msg.Msg == 0x100 //WM_KEYDOWN
				&& 0 != (Control.ModifierKeys & Keys.Control)) 
			{
				//ctl+A pressed
				SelectAllRecords();
				e.Inner.Handled = true;
				e.Inner.Result = true;
			}
			
		}


		private void SelectAllRecords()
		{
			this.gridGroupingControl1.BeginUpdate();
			foreach(GridRecord rec in gridGroupingControl1.Table.Records) 
			{
				if(!rec.IsSelected())
					rec.SetSelected(true);
			}
			this.gridGroupingControl1.EndUpdate(true);
		}

		private void gridGroupingControl1_TableControlKeyDown(object sender, GridTableControlKeyEventArgs e)
		{
			if(e.Inner.KeyCode == Keys.A && 0 != (Control.ModifierKeys & Keys.Control))
			{
				SelectAllRecords();
				e.Inner.Handled = true;
			}
		}

		private void CopySelectedRecords()
		{
			String s = "";
			foreach(SelectedRecord rec in this.gridGroupingControl1.Table.SelectedRecords)
			{
				
				for(int i = 0; i < this.gridGroupingControl1.TableDescriptor.Fields.Count; ++i)
				{
					FieldDescriptor fd = this.gridGroupingControl1.TableDescriptor.Fields[i];
					if(i != 0)
						s += '\t';
					s += rec.Record.GetValue(fd).ToString();
				}
				s += Environment.NewLine;
			}
			Clipboard.SetDataObject(new DataObject(s), true);
			Console.WriteLine(s);
			 
		}

		private void Model_ClipboardCopy(object sender, GridCutPasteEventArgs e)
		{
			CopySelectedRecords();
			e.Handled = true;
		}


		private void button1_Click(object sender, System.EventArgs e)
		{
			int iCurrRow=gridGroupingControl1.TableControl.CurrentCell.RowIndex;
			int iCurrCol=gridGroupingControl1.TableControl.CurrentCell.ColIndex;
			if (iCurrRow>=0 && iCurrCol>=0)
			{
				// chage cell value by code
				gridGroupingControl1.TableModel[iCurrRow, iCurrCol].CellValue=99;
				gridGroupingControl1.TableModel[iCurrRow+1, iCurrCol].CellValue=99;
				// refresh the change to source table
				gridGroupingControl1.Table.EndEdit();
			}
			else
			{
				MessageBox.Show("Please click in a cell with value.");
				return;
			}

			// need to refresh
			DataTable dtSource=gridGroupingControl1.DataSource as DataTable;
			DataTable dtChanged=dtSource.GetChanges();
			if (dtChanged!=null && dtChanged.Rows.Count>0)
			{
				MessageBox.Show(string.Format("There are {0} row changed",dtChanged.Rows.Count));
			}

		}
	}
}
